VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Batch Run"
   ClientHeight    =   2550
   ClientLeft      =   6990
   ClientTop       =   5295
   ClientWidth     =   3255
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   2550
   ScaleWidth      =   3255
   Begin VB.TextBox RunToFrame 
      Alignment       =   1  'Right Justify
      BeginProperty DataFormat 
         Type            =   1
         Format          =   "0"
         HaveTrueFalseNull=   0
         FirstDayOfWeek  =   0
         FirstWeekOfYear =   0
         LCID            =   1033
         SubFormatType   =   1
      EndProperty
      Height          =   375
      Left            =   1440
      TabIndex        =   3
      Text            =   "100"
      Top             =   240
      Width           =   735
   End
   Begin VB.TextBox CurrentFrame 
      Alignment       =   1  'Right Justify
      BackColor       =   &H8000000F&
      BorderStyle     =   0  'None
      BeginProperty DataFormat 
         Type            =   1
         Format          =   "0"
         HaveTrueFalseNull=   0
         FirstDayOfWeek  =   0
         FirstWeekOfYear =   0
         LCID            =   1033
         SubFormatType   =   1
      EndProperty
      Height          =   375
      Left            =   1440
      Locked          =   -1  'True
      TabIndex        =   8
      Top             =   720
      Width           =   735
   End
   Begin VB.TextBox SaveRate 
      Alignment       =   1  'Right Justify
      BeginProperty DataFormat 
         Type            =   1
         Format          =   "0"
         HaveTrueFalseNull=   0
         FirstDayOfWeek  =   0
         FirstWeekOfYear =   0
         LCID            =   1033
         SubFormatType   =   1
      EndProperty
      Height          =   375
      Left            =   1440
      TabIndex        =   1
      Text            =   "10"
      Top             =   1200
      Width           =   735
   End
   Begin VB.CommandButton Stop 
      Caption         =   "Stop"
      Height          =   375
      Left            =   1920
      TabIndex        =   6
      Top             =   1920
      Width           =   1095
   End
   Begin VB.CommandButton Run 
      Caption         =   "Run"
      Height          =   375
      Left            =   240
      TabIndex        =   5
      Top             =   1920
      Width           =   1095
   End
   Begin VB.Label Label5 
      Caption         =   "Current frame:"
      Height          =   255
      Left            =   240
      TabIndex        =   7
      Top             =   720
      Width           =   1095
   End
   Begin VB.Label Label3 
      Caption         =   "Run to frame:"
      Height          =   255
      Left            =   240
      TabIndex        =   4
      Top             =   240
      Width           =   1095
   End
   Begin VB.Label Label2 
      Caption         =   "frames"
      Height          =   255
      Left            =   2280
      TabIndex        =   2
      Top             =   1200
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Save every"
      Height          =   255
      Left            =   240
      TabIndex        =   0
      Top             =   1200
      Width           =   1095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Batch Run - last updated 2/13/01
'
' Description
'
' This sample VisualBasic project shows you how to write a simple tool that communicates with
' visualNastran Desktop.
'
' The application will run the currently active document until the requested frame is reached
' It will also save the document to disk periodically
'
' First, we look for the currently active vN Desktop application by calling:
'
'   Set app = GetObject(, "WM3D.Application")
'
' Then, when the user clicks Run, we find the active document and get hold of it's Simulation object.
' The Simulation object has a Run method that we call.  The simulation object also fires events when
' it starts to run, when a new frame is reached, and when it stops running.  We patch into these events
' to update the dialog state and to save the document periodically.
'


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Declarations
'

Dim app As Wm3d.Application ' The application

Dim doc As Wm3d.Document    ' The current document

' We declare the simulation object with the WithEvents keyword so that we can get fired events
Dim WithEvents simulation As Wm3d.simulation
Attribute simulation.VB_VarHelpID = -1

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Initialization
'
Private Sub Form_Load()
    
    ' First try to connect to the active application
    On Error GoTo cantconnect
    Set app = GetObject(, "WM3D.Application")
    UpdateControls False
        
    Exit Sub
cantconnect:
    MsgBox "visualNatran Desktop isn't running. Please launch it first.", , "Batch Run"
    ' Quit BatchRun
    End
End Sub

Private Sub UpdateControls(running As Boolean)
    Form1.RunToFrame.Enabled = Not running
    Form1.SaveRate.Enabled = Not running
    Form1.Run.Enabled = Not running
    Form1.Stop.Enabled = running
End Sub

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Events fired from the simulation
'
Private Sub simulation_RunStarted()
    ' We're running. Disable the controls
    UpdateControls True
End Sub

Private Sub simulation_RunStopped()
    ' We're no longer running
    UpdateControls False
End Sub

Private Sub simulation_FrameChanged(ByVal frame As Long)
    ' A new frame has been computed
    
    ' Update the frame counter
    Form1.CurrentFrame.Text = Str(frame)
    
    ' See if we need to save...
    If frame Mod Form1.SaveRate = 0 Then
        doc.Save
    End If
    
    ' Stop the simulation if we're done
    If frame >= Form1.RunToFrame Then
        simulation.Stop
    End If
    
End Sub

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' Dialog events
'
Private Sub Run_Click()
    ' The user pressed the run button, so start the simulation
    Set doc = app.ActiveDocument
    If doc Is Nothing Then
        MsgBox "No active document.", , "Batch Run"
    Else
        If doc.FullName = "" Then
            MsgBox "You must save the document once before continuing.", , "Batch Run"
        Else
            Set simulation = doc.simulation
            
            ' Run the simulation.  Note that we'll catch events to keep track of what is going on
            simulation.Run
        End If
    End If
End Sub

Private Sub Stop_Click()
    ' The user pressed the stop button, so stop the simulation
    If Not (simulation Is Nothing) Then
        simulation.Stop
    End If
End Sub
