Attribute VB_Name = "MainModule"
Public gPath As String
Public WM3DApp As Object
Public gRecursive As Boolean
Public gRepeatForever As Boolean
Public gNumfilesRun As Integer  ' keeps track of files opened and run for safeguard
Sub Main()
    gRecursive = False
    gRepeatForever = True
    gNumfilesRun = 0
    On Error GoTo NotRunning3D
    Set WM3DApp = GetObject(, "WM3D.Application")
    WM3DApp.Activate
    WM3DApp.Maximize
    
    CloseAllDocuments
    On Error GoTo 0
    
    
    ' Try to find a slideshow directory
    If Dir(App.Path + "\demo files\*.wm3") <> "" Then
        gPath = App.Path + "\demo files"
    ElseIf Dir(WM3DApp.CurrentDirectory + "\demo files\*.wm3") <> "" Then
        gPath = WM3DApp.CurrentDirectory + "\demo files"
    Else
        'Search the samples folder for a slidshow folder
        temp = CurDir
        
        ChDir App.Path
        ChDir ".."
        ChDir ".."
        
        If Dir(CurDir + "\demo files\*.wm3") <> "" Then
            ' Initial directory is the SlideShow directory
             gPath = CurDir + "\demo files"
        Else
            ' Initial directory is WM3D's current directory
            gPath = WM3DApp.CurrentDirectory
        End If
        ChDir temp
    End If
    
    ' Show the intro dialog
    Intro.Show
    Exit Sub
    
NotRunning3D:
    ' Could not find a running instance of Working Model 3D
    MsgBox "Please launch visulaNastran Desktop first.", vbExclamation
    Exit Sub
End Sub

Sub StartSlideShow()
    ' Entry point from the UI callback
    gPath = gPath + "\"
repeatforever:
    TraverseFolder gPath
    If (gNumfilesRun = 0) Then
        MsgBox "Specified folder contains no visualNastran Desktop files.", vbInformation
        End
    End If
    gNumfilesRun = 0    ' reset the counter
    If (gRepeatForever) Then
        GoTo repeatforever
    End If
End Sub

Sub CloseAllDocuments()
    Dim doc As Object
    Dim Response
    Dim saveChanges As Boolean
    Set doc = WM3DApp.ActiveDocument
    If (Not (doc Is Nothing)) Then
        ' Ask the user if s/he wishes to save the file
        Response = MsgBox("Slide Show will close all files that are currently open.  Would you like to save changes?", vbExclamation + vbYesNoCancel + vbDefaultButton3 + vbMsgBoxHelpButton, "Slide Show", "slidesho.hlp", 1000)
        If (Response = vbYes) Then
            saveChanges = True
        ElseIf (Response = vbNo) Then
            saveChanges = False
        Else
            End
        End If
    End If
    While ((doc Is Nothing) = False)
        doc.Close saveChanges
        Set doc = WM3DApp.ActiveDocument
    Wend
End Sub
' Number of directories allowed while traversing recursively
Sub TraverseFolder(ByVal aPath As String)
    Dim docs As Object
    Dim doc As Object
    ReDim directoryArray(256) As String
    Counter = 0
 
    Set docs = WM3DApp.Documents
    FileName = Dir(aPath + "*.wm3")
    
    ' Cycle through each document in the path and run the simulation
    While (FileName <> "")
        Set doc = docs.Open(aPath + FileName)
        WM3DApp.Tile
        RunSimulation doc
        doc.Close
        FileName = Dir
    Wend
    
    ' Traverse each directory
    If gRecursive Then
        ' Retrieve the first entry.
        subDir = Dir(aPath, vbDirectory)
        Do While subDir <> ""
            ' Ignore the current directory and the encompassing directory.
            If subDir <> "." And subDir <> ".." Then
                ' Use bitwise comparison to make sure MyName is a directory.
                If ((Counter < 256) And ((GetAttr(aPath & subDir) And vbDirectory) = vbDirectory)) Then
                    directoryArray(Counter) = aPath + subDir
                    Counter = Counter + 1
                End If  ' it represents a directory.
            End If
            subDir = Dir    ' Get next entry.
        Loop
    
        For Each directory In directoryArray
            If directory <> "" Then
                Call TraverseFolder(directory + "\")
            End If
        Next
    End If

End Sub
 
Sub RunSimulation(doc As Object)
    ' Given a Wm3D document object, runs the simulation while allowing the user
    ' to interrupt.
    nFrames = doc.NumFrames - 1 ' subtract two frames
    
    ' Disable Pause Control (should not erase history)
    doc.RunControl.ActionType = 0 ' none
    
    ' UI event loop is created.  Run the simulation, while watching for
    ' the UI event that may stop the WM3D simulation
    doc.RunTo nFrames, False
    While (doc.IsRunning)
            For I = 1 To 150000
                If I Mod 1000 = 0 Then
                    DoEvents
                End If
            Next I
    Wend
    doc.Stop
    
    If (doc.CurrentFrame < nFrames) Then
        ' Simulation was interrupted; prompt if the user wants to continue
        If (MsgBox("Continue with other files?", vbYesNo + vbMsgBoxSetForeground + vbQuestion, "Demo Runner") = vbNo) Then
            End
        Else
            WM3DApp.Activate ' MsgBox was in the foreground; bring the app back up front
        End If
    End If
    gNumfilesRun = gNumfilesRun + 1
End Sub
