// WMHELP.H
//
// Contains help context IDs.  Included in the app code and the Help project.

// Notes:	the first block of numbers are IDs used in the application code.
//			When the app calls WinHelp, MFC adds a proper offset to these IDs
//			and pass these numbers as context IDs.  Therefore, the second block
//			on IDs in this file are offset by certain numbers.  The offset depends
//			on the object that called the help.

// IMPORTANT!! The file is included in the help project, which CANNOT understand
// rudimentary arithmetic operations and secondary references such as:

//		#define ID_BLAH  0x3000+ID_DUH

// Instead, the syntax always needs to be:

//		#define <identifier string> <positive integer>

// for the sake of on-line help project.  Thank you for cooperation.
// [KT 7/10/96]


#define IDH_CONTENTS 1
#define KEYBOARD 110
#define GUIDED_TOUR 120
#define HIGH_ACCELERATION_ALERT  8102
#define HIGH_VELOCITY_ALERT 8103
#define REDUNDANT_CONSTRAINT_ALERT 8107
#define INCONSISTENT_CONSTRAINT_ALERT 8130
#define INITIAL_MASS_OVERLAP 8128
#define ZERO_LENGTH_CONSTRAINT	    8131
#define	HIGH_ANGULAR_ACCELERATION  8132
#define	TWO_ANCHOR_CONSTRAINT		8133
#define	STEP_TOO_SMALL				8134
#define HIGH_FORCE					8135
#define BAD_MASS					8136
#define	HIGH_MASS_RATIO			8137
#define	BAD_POLYHEDRON			8138
#define HIGH_ANGULAR_VELOCITY	8139
#define INCOMPLETE_POLYHEDRON	8140
#define CONSTRAINT_NAVIGATOR	9000
#define GL_COMPATIBILITY		9002
#define EXPLODE_TOOL			9004

// Context IDs offset properly to work with dialog boxes.
// 0x20000 is an offset specified by MFC (afxpriv.h), added to the
// dialog's resource ID.

#define HIDD_DISPLAY                            0x20532
#define HIDD_PRESCRIBED_MOTION                  0x20106
#define HIDD_PROP_ACCURACY                      0x2053C
#define HIDD_PROP_FRAME_RATE                    0x20536
#define HIDD_PROP_GRAVITY                       0x20534
#define HIDD_PROP_RUN_CONTROL                   0x20538
#define HIDD_PROP_NUMBERS                       0x20537
#define HIDD_PROP_UNITS                         0x20535
#define HIDD_PROP_GRID                          0x20539
#define HIDD_PROP_VECTORS                       0x2053A
#define HIDD_PROP_WARNINGS                      0x2053B
#define HIDD_PROP_FEA_DISPLAY                   0x206E9  // IDD_PROP_FEA + 0x20000
#define HIDD_PROP_FEA_RESULTS                   0x206F7  // IDD_PROP_FEA_RESULTS + 0x20000
#define HIDD_FEA_ANIMATION_OPTIONS              0x206F8	 // IDD_FEA_ANIMATION_OPTIONS + 0x20000
#define HIDD_FEA_CONTOUR_OPTIONS                0x206FA  // IDD_FEA_CONTOUR_OPTIONS + 0x20000
#define WHAT_IS_A_GENERIC_CONSTRAINT			0x2053D  // IDD_GENERIC_CONSTRAINT + 0x20000

// Context IDs offset properly to work with message boxes.
// 0x30000 is an offset specified by MFC (afxpriv.h) to distinguish
// help context IDs from any internal IDs used by the application code.


#define HIDP_HIGH_ACCELERATION_ALERT		204710  // 0x30000 + HIGH_ACCELERATION_ALERT		
#define HIDP_HIGH_VELOCITY_ALERT			204711  // 0x30000 + HIGH_VELOCITY_ALERT
#define HIDP_REDUNDANT_CONSTRAINT_ALERT		204715  // 0x30000 + REDUNDANT_CONSTRAINT_ALERT
#define HIDP_INCONSISTENT_CONSTRAINT_ALERT	204738	// 0x30000 + INCONSISTENT_CONSTRAINT_ALERT
#define HIDP_INITIAL_MASS_OVERLAP			204736	// 0x30000 + INITIAL_MASS_OVERLAP
#define HIDP_ZERO_LENGTH_CONSTRAINT			204739	// 0x30000 + ZERO_LENGTH_CONSTRAINT
#define	HIDP_HIGH_ANGULAR_ACCELERATION		204740	// 0x30000 + HIGH_ANGULAR_ACCELERATION
#define	HIDP_TWO_ANCHOR_CONSTRAINT			204741	// 0x30000 + TWO_ANCHOR_CONSTRAINT
#define	HIDP_STEP_TOO_SMALL					204742	// 0x30000 + STEP_TOO_SMALL
#define HIDP_HIGH_FORCE						204743	// 0x30000 + HIGH_FORCE
#define HIDP_BAD_MASS						204744	// 0x30000 + BAD_MASS
#define	HIDP_HIGH_MASS_RATIO				204745	// 0x30000 + HIGH_MASS_RATIO
#define	HIDP_BAD_POLYHEDRON					204746	// 0x30000 + BAD_POLYHEDRON
#define HIDP_HIGH_ANGULAR_VELOCITY			204747	// 0x30000 + HIGH_ANGULAR_VELOCITY	
#define HIDP_INCOMPLETE_POLYHEDRON			204748	// 0x30000 + INCOMPLETE_POLYHEDRON
#define HIDP_BAD_GENERIC_CONSTRAINT					204749	// (no counterparts above)
#define	HIDP_NON_EXISTENT_OBJECT_REFERENCE			204750	// (no counterparts above)
#define HIDP_FORCE_DEPENDENCE_ON_ACCELERATION		204751 	// (no counterparts above)
#define HIDP_HIGH_FORCE_BETWEEN_CONTACTING_BODIES	204752 	// (no counterparts above)
#define HIDP_HOW_TO_USE_ENGINE_ERROR_WINDOW			204753  // (no counterparts above)
#define HIDP_INVALID_INERTIA						204754  // (no counterparts above)
#define HIDP_DISPROPORTIONATE_INERTIA				204755  // (no counterparts above)
#define HIDP_CANT_COLLIDE_CONNECTED					204756  // (no counterparts above)
#define HIDP_CANT_COLLIDE_INDIRECTLY_CONNECTED		204757  // (no counterparts above)
#define HIDP_JOINT_JOINS_ANCHORED_AND_KEYFRAMED_BODIES		204758  // (no counterparts above)
#define HIDP_JOINT_JOINS_KEYFRAMED_BODIES			204759  // (no counterparts above)
#define HIDP_TABLE_DUPLICATE_DATA_ENTRIES	204760  // (no counterparts above)
#define HIDP_GL_COMPATIBILITY				205610	// 0x30000 + GL_COMPATIBILITY
#define HIDP_EXPLODE_TOOL					205612	// 0x30000 + EXPLODE_TOOL
